/**
  * Created by ariellemoro on 12.12.16.
  */

class Registration(student: Student, course: Course) {

  private var _student: Student = student
  private var _course: Course = course
  private var _grade: Double = 0.0
  private var _validated: Boolean = false

  //Methods executed just after the creation of the a Registration object
  _student.addNewCourse(_course)
  _course.addNewRegistration(this)

  //Getter: _student
  def getStudent(): Student = {
    return _student
  }

  //Getter: _grade
  def getGrade(): Double = {
    return _grade
  }

  //Setter: _grade
  def setGrade(grade:Double): Unit = {
    _grade = grade
  }

  //Function that validates the course for the student registered
  def setValidation(): Unit = {
    _validated = true
    _student.updateCreditNumber(_course.getCreditNumber())
    _student.displayNotification(s"You have passed the course ${_course.toString} with the grade ${_grade}/6.0")
    _student.storeCourse(_course, _grade)
  }

}
