/**
  * Created by ariellemoro on 12.12.16.
  */
object UnilProject {

  def main(args: Array[String]): Unit = {
    //1. Create 4 students
    val student1:Student = new Student("A", "C", 1)
    val student2:Student = new Student("Y", "B", 2)
    val student3:Student = new Student("B", "M", 3)
    val student4:Student = new Student("L", "Z", 4)
    //2. Create 1 professor as well as a course
    val professor:Professor = new Professor("B", "G", "IS")
    val course:Course = new Course("ACT", 6, professor)
    //3. These 4 students register for the course, i.e., create 4 registrations
    val registration1 = new Registration(student1, course)
    val registration2 = new Registration(student2, course)
    val registration3 = new Registration(student3, course)
    val registration4 = new Registration(student4, course)
    //4. Display the list of students based on the registrations, the professor perform the exam, set the grades of the students and the notifications are sent to the students
    //Print the students of the created course
    var index = 0
    for (registration <- course.getRegistrations("ACT")){
      println(s"Registration n°$index ${registration.getStudent().toString}")
      index += 1
    }
    //Perform the exam
    course.performExam()
    //Set the grades
    course.setGrade(1, 6.0)
    course.setGrade(2, 6.0)
    course.setGrade(3, 3.5)
    course.setGrade(4, 4.0)
    //Display exam stats
    course.displayExamStats()
    //Finish the semester
    course.finishSemester()
    //Display the status of all students
    index = 0
    for (registration <- course.getRegistrations("ACT")){
      println(s"Registration n°$index ${registration.getStudent().toString}")
      index += 1
    }
    //RETAKE STEP => Perform the exam
    course.performExam()
    //Set the grades
    course.setGrade(3, 5.5)
    //Display exam stats
    course.displayExamStats()
    //Finish the semester
    course.finishSemester()
    //Display the status of all students
    index = 0
    for (registration <- course.getRegistrations("ACT")){
      println(s"Registration n°$index ${registration.getStudent().toString}")
      index += 1
    }
  }

}
